| The Gaudi Framework v28r2-patches (bc4ad17a)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Protected Member Functions | Private Attributes | List of all members
Google::HeapProfiler Class Reference

Auditor based on the Google Heap Profiler. More...

`#include <GoogleAuditor.cpp>`

Inheritance diagram for Google::HeapProfiler:
[legend]
Collaboration diagram for Google::HeapProfiler:
[legend]

## Protected Member Functions
void | google_before (const std::string &s) override
| Start the google tool. More...
void | google_after (const std::string &s) override
| stop the google tool More...
bool | alreadyRunning () override
| check if we are already running the tool More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IAuditor, IProperty > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IAuditor, IProperty > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Private Attributes
Gaudi::Property< bool > | m_dumpProfileHeaps {this, "DumpHeapProfiles", true, ""}
Gaudi::Property< bool > | m_printProfilesToLog {this, "PrintProfilesToLog", false, ""}

## Additional Inherited Members
Public Types inherited from extends< Auditor, IIncidentListener >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Auditor
typedef Gaudi::PluginService::Factory< IAuditor *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from PropertyHolder< CommonMessaging< implements< IAuditor, IProperty > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IAuditor, IProperty > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IAuditor, IProperty > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Public Member Functions inherited from Google::AuditorBase
| ~AuditorBase () override=default
| Destructor. More...
StatusCode | initialize () override
| Initialize the auditor base. More...
StatusCode | finalize () override
| Finalize the auditor base. More...
void | handle (const Incident &incident) override
| Implement the handle method for the Incident service. More...
void | before (StandardEventType type, INamedInterface *i) override
void | before (CustomEventTypeRef type, INamedInterface *i) override
void | before (StandardEventType type, const std::string &s) override
void | before (CustomEventTypeRef type, const std::string &s) override
void | after (StandardEventType type, INamedInterface *i, const StatusCode &sc) override
void | after (CustomEventTypeRef type, INamedInterface *i, const StatusCode &sc) override
void | after (StandardEventType type, const std::string &s, const StatusCode &sc) override
void | after (CustomEventTypeRef type, const std::string &s, const StatusCode &) override
void | beforeInitialize (INamedInterface *i) override
void | beforeReinitialize (INamedInterface *i) override
void | beforeExecute (INamedInterface *i) override
void | beforeBeginRun (INamedInterface *i) override
void | beforeEndRun (INamedInterface *i) override
void | beforeFinalize (INamedInterface *i) override
void | afterInitialize (INamedInterface *i) override
void | afterReinitialize (INamedInterface *i) override
void | afterExecute (INamedInterface *i, const StatusCode &s) override
void | afterBeginRun (INamedInterface *i) override
void | afterEndRun (INamedInterface *i) override
void | afterFinalize (INamedInterface *i) override
Public Member Functions inherited from extends< Auditor, IIncidentListener >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Auditor
| Auditor (const std::string &name, ISvcLocator *svcloc)
| Constructor. More...
| Auditor (const Auditor &a)=delete
Auditor & | operator= (const Auditor &rhs)=delete
StatusCode | sysInitialize () override
| Initialization method invoked by the framework. More...
StatusCode | sysFinalize () override
| Finalization method invoked by the framework. More...
void | before (StandardEventType, INamedInterface *) override
| The following methods are meant to be implemented by the child class... More...
void | before (StandardEventType, const std::string &) override
void | before (CustomEventTypeRef, INamedInterface *) override
void | before (CustomEventTypeRef, const std::string &) override
void | after (StandardEventType, INamedInterface *, const StatusCode &) override
void | after (StandardEventType, const std::string &, const StatusCode &) override
void | after (CustomEventTypeRef, INamedInterface *, const StatusCode &) override
void | after (CustomEventTypeRef, const std::string &, const StatusCode &) override
void | beforeInitialize (INamedInterface *) override
void | afterInitialize (INamedInterface *) override
void | beforeReinitialize (INamedInterface *) override
void | afterReinitialize (INamedInterface *) override
void | beforeExecute (INamedInterface *) override
void | afterExecute (INamedInterface *, const StatusCode &) override
void | beforeFinalize (INamedInterface *) override
void | afterFinalize (INamedInterface *) override
void | beforeBeginRun (INamedInterface *) override
void | afterBeginRun (INamedInterface *) override
void | beforeEndRun (INamedInterface *) override
void | afterEndRun (INamedInterface *) override
const std::string & | name () const override
bool | isEnabled () const override
SmartIF< ISvcLocator > & | serviceLocator () const override
| The standard service locator. More...
template<class T >
StatusCode | service (const std::string &name, T *&svc, bool createIf=false) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T = IService>
SmartIF< T > | service (const std::string &name, bool createIf=false) const
StatusCode | setProperties ()
| Set the auditor's properties. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IAuditor, IProperty > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Detailed Description

Auditor based on the Google Heap Profiler.

See

http://google-perftools.googlecode.com/svn/trunk/doc/heapprofile.html

For more details.

Author
  Chris Jones

Date
  18/04/2011

Definition at line 294 of file GoogleAuditor.cpp.

## Member Function Documentation

bool Google::HeapProfiler::alreadyRunning | ( |  | ) |
| inline override protected virtual

check if we are already running the tool

Implements Google::AuditorBase.

Definition at line 317 of file GoogleAuditor.cpp.

317 { return IsHeapProfilerRunning(); }

void Google::HeapProfiler::google_after | ( | const std::string & | s | ) |
| inline override protected virtual

stop the google tool

Implements Google::AuditorBase.

Definition at line 304 of file GoogleAuditor.cpp.

305 {
306 if ( m_dumpProfileHeaps ) {
307 HeapProfilerDump( s.c_str() );
308 }
309 if ( m_printProfilesToLog ) {
310 const char* profile = GetHeapProfile();
311 info() << profile << endmsg;
312 delete profile;
313 }
314 HeapProfilerStop();
315 }
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:123
Google::HeapProfiler::m_dumpProfileHeaps
Gaudi::Property< bool > m_dumpProfileHeaps
Definition: GoogleAuditor.cpp:320
Google::HeapProfiler::m_printProfilesToLog
Gaudi::Property< bool > m_printProfilesToLog
Definition: GoogleAuditor.cpp:321
std::string::c_str
T c_str(T...args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

void Google::HeapProfiler::google_before | ( | const std::string & | s | ) |
| inline override protected virtual

Start the google tool.

Implements Google::AuditorBase.

Definition at line 302 of file GoogleAuditor.cpp.

302 { HeapProfilerStart( s.c_str() ); }
std::string::c_str
T c_str(T...args)

## Member Data Documentation

Gaudi::Property<bool> Google::HeapProfiler::m_dumpProfileHeaps {this, "DumpHeapProfiles", true, ""}
| private

Definition at line 320 of file GoogleAuditor.cpp.

Gaudi::Property<bool> Google::HeapProfiler::m_printProfilesToLog {this, "PrintProfilesToLog", false, ""}
| private

Definition at line 321 of file GoogleAuditor.cpp.

The documentation for this class was generated from the following file:

- GaudiProfiling/src/component/google/GoogleAuditor.cpp